import numpy as np
import pandas as pd


#make function to read .csv file and return dataframe
def leggi_csv(file_name):
    df = pd.read_csv(file_name)
    return df

#make function to read .xls file and return dataframe
def leggi_xls(file_name):
    df = pd.read_excel(file_name)
    return df


#make function to read .xlsx file and return dataframe
def leggi_xlsx(file_name):
    df = pd.read_excel(file_name)
    return df

#make function to read .html file and return dataframe
def leggi_html(file_name):
    df = pd.read_html(file_name)
    return df

#make function to read .json file and return dataframe
def leggi_json(file_name):
    df = pd.read_json(file_name)
    return df   

#make function to read .sql file and return dataframe
def leggi_sql(file_name):
    df = pd.read_sql(file_name)
    return df  

#make function to return statistics of dataframe
def statistiche(df):
    return(df.describe())

#make function to return dataframe with only numeric values
def numerici(df):
    return(df.select_dtypes(include=['number']))

#make function to return dataframe with only categorical values
def categorici(df):
    return(df.select_dtypes(include=['object']))

#make function to return dataframe with only boolean values
def booleani(df):
    return(df.select_dtypes(include=['bool']))

#make function to remove from dataframe rows with missing values
def rimuovi_nan(df):
    return(df.dropna())

#make function to count missing value for column in dataframe
def conta_nan(df):
    return(df.isnull().sum())   

#make function to remove specific colmn from dataset
def rimuovi_colonna(df, colonna):
    return(df.drop(colonna, axis=1))

#make function to remove specific row from dataset
def rimuovi_riga(df, riga):
    return(df.drop(riga, axis=0))

#make function to label encoding categorical values
def label_encoding(df, colonna):
    return(df[colonna].astype('category').cat.codes)

#make function to onehot encoding categorical values
def onehot_encoding(df, colonna):
    return(pd.get_dummies(df[colonna]))

#make function to apply sql query on dataframe
def sql_query(df, query):
    return(df.query(query))

#make function to normalize dataframe
def normalizza(df):
    return(df.apply(lambda x: (x - np.min(x)) / (np.max(x) - np.min(x))))

#make function to scaling dataframe
def scaling(df):
    return(df.apply(lambda x: (x - np.mean(x)) / (np.std(x))))

#make function to return variance of dataframe
def varianza(df):
    return(df.var())    

#make function to return covariance of dataframe
def covarianza(df):
    return(df.cov())

#make function to return correlation of dataframe
def correlazione(df):
    return(df.corr())

#make function to return correlation matrix of dataframe
def correlazione_matrice(df):
    return(df.corr().round(2))

#make function to return radio correlation on column in dataframe
def correlazione_radio(df, colonna, target):
    return(df[colonna].corr(df[target]))

